/*
 *响站客服聊天系统
 */

(function(){
	if(!parent)return;
	
	var contentList=$('#contentList'),
		titleEl=$('#title'),
		sendBtn=$('#sendBtn'),
		contentInput=$("#input_content");
	
	var conn=false,
		SiteInfo=parent.SiteInfo,
		visitorInfo=parent.visitorInfo,
		delayReply,
		delayRespond,
		autoReplyMsg={'welcomeMsg':'欢迎访问',
					  'waitTimeout':'不好意思，请稍等',
					  'resTimeout':'请问还在吗？',
						'busy':'我正在忙',
						'queue':'你已进入排队。',
						'replyTime':60000,
						'respondTime':60000,
						'noServices':'没有客服在线'
					 };
	
	
	var url=urlToJson(decodeURI(windowURL)),
		status=url.status||'',
		servicesId=url.servicesId,
		siteId=SiteInfo.siteId,
		clientKey=SiteInfo.clientKey,
		guest=SiteInfo.userId?false:true,
		userId=SiteInfo.userId||clientKey,
		nickName=SiteInfo.userNickName,
		sourcesURL=parent.windowURL,
		sources=visitorInfo.sources,
		ip=visitorInfo.ip,
		icon=SiteInfo.userIcon||'',
		
		services={
			servicesId:servicesId
		},
		delayDisconnectTime=1000*60*3,//延迟断线时间
		delayDisconnect;
	
	if(!(siteId&&userId))return;
	
	
	
	/**
	 *socket连接
	 */
	function connect(){
		 $('#request').remove();
		 $('#chat').show();
		
		 //如果是连接中的切换页面，则显示最小化对话窗口
		 if(status=='connecting'){
			 
			  if(parent.$('#xzMessage').hasClass('none')){
				  parent.$('#xzMessage').removeClass('none').addClass('hide');
				  getMessageWindowMask();
			  };
		 };
		 status='reconnect'; 
			  
		var socket = io('http://im.'+domain);
		socket.on('connect', function () {
			   var data={
						talkKey:getNowRandom(),
						siteId:siteId,
						userType:'custom',
						userId:userId,
						clientKey:clientKey,
						nickName:nickName,
						servicesId:services.servicesId,
						sourcesURL:sourcesURL,
						sources:sources,
						ip:ip,
						icon:icon,
						guest:guest,
						status:status,
						time:getNowDate('all')
					};
			 socket.emit('customLogin', data,function(backData){
				 //tests('r'+backData);
			 });
			
		});
		
		//连接客服成功
		socket.on('customConnSuccess', function (backData) {
				services=backData;
				titleEl.html(backData.servicesName);
				$('div[role="queue"]',contentList).remove();
				socket.servicesId=backData.servicesId;
				if(backData.message&&backData.message.length){
					$.each(backData.message,function(i,item){
						if(item.type=='msgToServices'){
							myMsg({
								msg:item.msg,
								time:item.time,
								id:item.id
								});
						}else{
							getMsg({
								msg:item.msg,
								time:item.time,
								id:item.id
								});
						};
					});
				}else{
					getMsg({
						msg:autoReplyMsg.welcomeMsg,
						time:getNowDate('all'),
						id:'welcome'
						});
				};
				
				conn=true;
				
				//设置cookie
				$.cookie('servicesId',backData.servicesId,{path:'/'});
				
								
				$('#chat').removeClass('offline');
				$('#messageSendBox').show();
				newMessage();
				clearDelayReply();
				setDelayRes();
							
		});
		
		//连接客服失败
		socket.on('customLoginFailure', function (backData) {
				
				 
					   
				switch(backData.code){
					case '001':
						notice(autoReplyMsg.noServices);
					break;
					case '002':
						if(parent&&typeof parent.resetsXZCS=='function'){
							parent.resetsXZCS();
						};
					break;
				};
				
				//断开连接
				socket.disconnect();  
		});
		
		//进入排队等候
		socket.on('toQueue', function (backData) {
				$('div[role="queue"]',contentList).remove();
				notice(autoReplyMsg.queue,'queue');
				//设置cookie
				$.cookie('servicesId','queue',{path:'/'});
				
		});
		
		//客服下线
		socket.on('servicesDisconnect', function (backData) {
				notice(autoReplyMsg.busy);
		});
		
		//连接断开
		socket.on('disconnect', function (backData) {
				//tests('连接已断开');
				/*delayDisconnect=setTimeout(function(){
					notice('连接已断开');
					conn=false;
					delayDisconnect=null;
				},delayDisconnectTime);*/
				
		});
		
		//重新连接服务器
		socket.on('reconnect', function() {
			 /* customLogin();
			  if(delayDisconnect){
				  clearTimeout(delayDisconnect);
			  };*/
		});
		
		//接收客服消息
		socket.on('msgFromServices', function (data,callback) {
			   getMsg(data);
			   newMessage();
			   clearDelayReply();
			   setDelayRes();
			   if($.isFunction(callback)){
					callback(1);
				};
		 });
		 
		 //接收本人在其他会话窗口发送的消息
		socket.on('msgFromMe', function (data) {
			   myMsg(data);
		 });
				
		
		//播放通知
		function notice(msg,role){
			 var data={
					msg:msg,
					time:getNowDate('all'),
					type:'system'
				 };
			 insertChatMessage(contentList,[data],true,role);
			 newMessage();
		 };
		 
		 //插入我的消息
		 function myMsg(data,isLoad){
			 data.type='msgToServices';
			 insertChatMessage(contentList,[data],true,'',isLoad);
			 //清除计时器
			 clearDelayReply();
		 };
		 
		 //插入接收的消息
		 function getMsg(data){
			 data.type='msgToCustom';
			 if(!data.icon){
				data.icon=services.icon; 
			 };
			 insertChatMessage(contentList,[data],true);
			 
		 };
		 
		 //设置超时自动响应
		function setDelayRes(){
			if(delayRespond){
				clearTimeout(delayRespond);
			};
			delayRespond=setTimeout(function(){
				getMsg({
						msg:autoReplyMsg.resTimeout,
						time:getNowDate('all'),
						id:'resTimeout'
						});
			},autoReplyMsg.respondTime);
		};
		
		//设置超时自动回应
		function setDelayReply(){
			if(delayReply){
				clearTimeout(delayReply);
			};
			delayReply=setTimeout(function(){
				getMsg({
						msg:autoReplyMsg.waitTimeout,
						time:getNowDate('all'),
						id:'waitTimeout'
						});
			},autoReplyMsg.replyTime);
		};
		
		//清除计时器
		function clearDelayReply(){
			if(delayRespond){
				clearTimeout(delayRespond);
				delayRespond=null;
			};
			if(delayReply){
				clearTimeout(delayReply);
				delayRespond=null;
			};
		};
		 
		 //插入对话消息
		function insertChatMessage(el,data,news,role,isLoad){
			if(data&&data.length){
				var container=el,
					showTime=true,
					lastTime=0,
					timeEl=container.find('div[role="showTime"]:'+(news?'last':'first'));
				if(timeEl.length){
					lastTime=timeEl.data('time');
				};
				$.each(data,function(i,item){
					if(item.type=='system'||!container.find('div[data-id="'+item.id+'"]').length){
						 var icon=item.type=='msgToCustom'?item.icon:icon;
						 if(item.time){
							item.time=item.time.replace(/-/g,"/");
						 };
						 if(news){	 
							 showTime=new Date(item.time)-new Date(lastTime)>1000*60*5;
						 }else{
							 showTime=new Date(lastTime)-new Date(item.time)>1000*60*5;
						 };
						 var div=$('<div class="message '+(item.type=='msgToCustom'?'you':item.type=='msgToServices'?'me':'system')+'"  data-id="'+(item.id||'')+'" role="'+(role||'')+'" >'+
									'<div class="messageSystem" role="showTime" data-time="'+item.time+'" '+(showTime?'':'style="display:none"')+'>'+
									'<span class="content">'+item.time+'</span></div>'+
									(item.type=='system'?'':'<span class="face">'+getThumbIcon(icon)+'</span>')+
									'<div class="content">'+
										'<div class="bubble '+(isLoad?'cloading" '+(item.id?' id="cloading_'+item.id+'"':''):'"')+'>'+
											'<div class="plain">'+msgToFile(item.msg)+'</div>'+
										'</div>'+
									'</div>'+
								'</div>');
						if(news){
							div.appendTo(container);
						}else{
							div.prependTo(container);
						};
						
						div.find('img[role="msgFile"]').on(click,function(e){
							viewMsgFile($(this),container);
						}).setThumbImageView();
						
						lastTime=item.time;
					};					
				});
				if(news){
					el.parent().scrollToBottom();
				};	
			};
			
		};
			
		
		 
		 //获取头像
		function getThumbIcon(icon){
			var html='';
			if(icon){
				html='<img src="'+getCropImageView(icon,40,40)+'" />';
			};
			return html;
		};
		
		//发送信息
		sendMessage=function(data,msg){
			var time=getNowDate('all');
			var id=getNowRandom();
			
			//把发送的信息先添加到自己的浏览器 DOM 中
			myMsg({msg:msg,time:time,id:id,type:'msgToServices'},true);
							
			//发送发话信息
			socket.emit('msgToServices',{msg: msg,time:time,id:id},function(){
				$('#cloading_'+id).removeClass('cloading');
				setDelayReply();
			});
		};
		 
			
		 //发话
		  sendBtn.on(click,function(e) {
			e.preventDefault();
			if(!conn)return;
			
			//获取要发送的信息
			var msg = contentInput.val().replace(/\n/g,"<br/>"),
				checkEl=$('<div />').html(msg),
				checkText=checkEl.text();
		
			checkEl.remove();
			if(checkText){
				sendMessage('',checkText);
			};			
			
			//清空输入框并获得焦点
			contentInput.val('').focus();
			
				
		 });
		 
		 $('#addMoreOperate').on(click,function(e){
			 e.stopPropagation();
			 var mask=$('<div class="mask"></div').insertAfter('#contentList').show();
			 $('#moreOperate').addClass('open');
			 $(document).one(click,function(){
				  $('#moreOperate').removeClass('open');
				  mask.remove();
			 });
		 });
		 
		
		 
		 $('#moreOperate').delegate('a[role]',click,function(){
			  switch($(this).attr('role')){
				  case 'image':
					xzUpload({
					  selectCount:9,
					  type:'user',
					  appId:'xzcs',
					  siteId:SiteInfo.siteId,
					  userId:SiteInfo.userId?SiteInfo.userId:'clientKey_'+SiteInfo.clientKey,
					  callBack:function(sdata){
						  $.each(sdata,function(i,item){
							  sendImg('',item.file);
						  });
					  }
				  });
				  break;
			  };
		  });
		  
		
		  
		 contentInput.on({'keyup':function(e){
				
				if(e.keyCode==16||e.keyCode==17){
						  var et=$(this);
						  setTimeout(function(){
							  et.removeData('shift');
						  },100);
				};
				if(e.keyCode==13&&!$(this).data('shift')){
						sendBtn.trigger(click);
					};
				 if($(this).val()!=''){
					 $('#messageSendBox').addClass('focus');
					 sendBtn.removeClass('disabled');
				  }else{
					  $('#messageSendBox').removeClass('focus');
					 sendBtn.addClass('disabled');
				  }	
			  },
			  keydown:function(e){
				   if(e.keyCode==16||e.keyCode==17){
						$(this).data('shift',1);
					};
					
			  },
			blur:function(){
				$(this).trigger('keyup');	
			}
			});
	};
	
	
	
	//自动滚屏	
	function scrollScreen(){
		 contentList.parent().scrollToBottom();
		  
	 };
	
	/**
	 *有新的消息
	 */
	function newMessage(){
		var newMessageEl=$('#newMessage');
		if(newMessageEl.length){
			var num=newMessageEl.data('num')||0;
			num++;
			newMessageEl.addClass('new').data('num',num).find('i').text(num<100?num:'99+');
		};
	};
	
	
	
	/**
	 *控制消息窗口
	 */
	if(this!=top&&parent.$('#xzMessage')){ 
		var xzMessageWindow=parent.$('#xzMessage'),
			messageFullscreen=$('#messageFullscreen');
		
		
		messageFullscreen.on(click,function(e){
			messageFullscreen.toggleClass('full');
			xzMessageWindow.toggleClass('full');
			if($(this).hasClass('full')){
				$(this).find('i').addClass('xzicon-fullscreen1-exit').removeClass('xzicon-fullscreen1');
			}else{
				$(this).find('i').addClass('xzicon-fullscreen1').removeClass('xzicon-fullscreen1-exit');
			};
			e.stopPropagation();
		});
		
		
		
		/**
		 *隐藏消息窗口
		 */
		;function hideMessageWindow(){
			
			if(messageFullscreen.hasClass('full')){
				messageFullscreen.trigger(click);
			};
			xzMessageWindow.addClass('hide');
			getMessageWindowMask();
			
		};
		
		/**
		 *恢复消息窗口
		 */
		
		;function recoverMessageWindow(){
			
			xzMessageWindow.removeClass('hide');
			setMask(0);
			$('#customerContainer').show();
			$('#newMessage').remove();
			scrollScreen();
			
		};
		
		;function getMessageWindowMask(){
			setMask(1);
			$('#bodyMask').on(click,recoverMessageWindow);
			$('#customerContainer').hide();
			$('<div class="customBar" id="newMessage"><i class="xzicon-dialogue"></i></div>').appendTo('#body');
		};
		
				
		
		
		if(xzMessageWindow.hasClass('full')){
			messageFullscreen.addClass('full');
			messageFullscreen.find('i').addClass('xzicon-fullscreen1-exit').removeClass('xzicon-fullscreen1');
		}else if(xzMessageWindow.hasClass('hide')){
			getMessageWindowMask();
		};
		
		if(parent.isPhoneState){
			messageFullscreen.hide();
		};
		
		$('#closeMessageWindow').on(click,hideMessageWindow);
		parent.recoverMessageWindow=recoverMessageWindow;
		
	};
	
	function getWelcomeMsg(){
		rpcJSON('/message/getWelcomeMsg',{vsiteId:SiteInfo.siteId},function(backData){
			if(backData.replyTime){
				backData.replyTime*=1000;	
			};
			if(backData.respondTime){
				backData.respondTime*=1000;	
			};
			$.extend(true,autoReplyMsg,backData);
			connect();
		},connect);
	};
	
	rpcJSON('/site/getText','',function(backData){
		
		$.extend(true,SiteText,backData);
		sendBtn.text(SiteText.sendText);
		contentInput.attr('placeholder',SiteText.contentPlaceholder);
		$('#moreOperate').append('<a href="javascript:;" role="image"><i class="xzicon-image"></i><span>'+SiteText.photo+'</span></a>'); 
		getWelcomeMsg();
	});
	
}());
