/*
 *响站客服聊天系统
 */

(function(){
	
	var quickReplyData,
		quickReplyDialog;
		
	xzServices=function(data){
		
		//显示访客选项卡
		$('li[role="visitors"]',messageTab).show();
		
		//给服务器发送客服登录信息
		socket.emit('servicesLogin',data); 	
	};
		
	
	//客服登录成功回执
	socket.on('servicesLoginSuccess', function (backData) {
			//客服坐席登录，更新数据
			/*if(backData.chats&&backData.chats.length){
				var arr=[];
				$.each(backData.chats,function(i,item){
					item.type='chat';
					item.id=item.userId;
					item.name=item.nickName;
					item.online=true;
					arr.push(item);
				});
				
				createChatList(arr);
			};*/
			//更新会话列表
			rpcJSON('/message/getchatMsg','',function(msgData){
				createChatList(msgData,true);
			});
			
			//更新队列信息
			if(backData.queue&&backData.queue.length){
				$.each(backData.queue,function(i,item){
					insertQueue(item);
				});
			};
			
			//更新访客信息
			if(customContainer.data('ready')){
				getCustom(true);
			};
			
			if(!quickReplyData){
				rpcJSON('/message/getQuickReply','',function(rData){
					if(rData.length){
						quickReplyData=rData;
					};
				});
			};
			
	});
	
	//有客户连接客服
	socket.on('customConnect', function (backData) {
			var chatLi=$('#chat_'+backData.userId);
			insertChat({
				name:backData.nickName,
				id:backData.userId,
				clientKey:backData.clientKey,
				type:'chat',
				icon:backData.icon,
				news:chatLi.length&&chatLi.hasClass('active')?0:1,
				latest:{
					type:'msgToServices',
					time:getNowDate('all'),
					msg:'连接客服'
				}		 
			 });
			
			//更新客户状态 
			setCustomState(backData,'online');
			
			//更新访客信息
			updateCustom(backData);
			
	});
	
	//有客户进入排队
	socket.on('customQueue', function (backData) {
			
			insertQueue(backData);
			playSound('online');
	});
	
	//客户退出排队
	socket.on('exitQueue', function (backData) {
			exitQueue(backData);
	});
	
	//客户断开连接
	socket.on('customDisconnect', function (backData) {
			//tests('客户下线'+backData);
			setCustomState(backData,'offline');
	});
	
	
	//接收客户消息
	socket.on('msgFromCustom', function (backData,callback) {
			getMsg(backData);
			
			//反馈消息读取状态
			var read=$('#chat_'+backData.user.userId).hasClass('active')?1:0;
			if(!read){
				playSound('message');
			};
			if($.isFunction(callback)){
				callback(read);
			};
			
	});
	
	//接收本人在其他会话窗口发送的消息
	socket.on('msgFromMe', function (data) {
		   myMsg(data);
	});
	
		
	 
	 
	//创建对话窗口
	createTalkBox=function(data){
		var html='<div class="chatDetailHead chatHead">'+
				  '<a class="return" href="javascript:;" role="back"><i class="xzicon-arrow-l"></i></a>'+
				  '<p class="title">'+data.name+'</p>'+
				  '<a class="rightBtn" href="javascript:;" role="more">更多</a>'+
			  '</div>'+
			  '<div class="chatDetailMain chat"><div role="chatDetailWrapper"></div></div>'+
			  '<div class="chatDetailSend">'+
				  '<div class="sendBox">'+
					  '<div class="content">'+
						  '<form><textarea class="messageEditor text_input" placeholder="输入内容按换行键发送" ></textarea></form>'+
					  '</div>'+
					  '<a href="javascript:;" class="sendOut disable" role="sendBtn">发送</a>'+
					  '<div class="operate">'+
						'<a href="javascript:;" class="send" role="quickReplyBtn"><i class="xzicon-quickReply"></i></a>'+
						'<a href="javascript:;" class="add"><i class="xzicon-addround"></i></a>'+
					  '</div>'+
				  '</div>'+
				  '<div class="moreOperate">'+
        			'<a href="javascript:;" role="image"><i class="xzicon-image"></i><span>图片</span></a>'+
					'</div>'+
			  '</div>';
	  
	  var talkBox=$('<div class="chatDetail" role="chatDetail" id="chatDetail_'+data.id+'"  type="'+data.type+'">'+html+'</div>'),
	  	  textarea=$('textarea',talkBox);
	  
	  talkBox.data('data',data).appendTo(chatContainer);
	  talkBox.delegate('a[role="more"]',click,function(){
		  if(isOpenWindow){
			  openCustomDetailWindow(data);
		  }else{
			  $('div.chatList li.active').removeClass('active');
			  viewMore(data);
		  };
	  });
	  $('div.sendBox a.add',talkBox).on(click,function(e){
		  e.stopPropagation();
		  var moreOperate=$('div.moreOperate',talkBox),
		  	  mask=$('<div class="mask"></div').appendTo('div.chatDetailMain',talkBox).show();
		  moreOperate.addClass('open');
		  $(document).one(click,function(){
			  mask.remove();
			  moreOperate.removeClass('open');
		  });
		  
	  });
	  
	  $('div.moreOperate',talkBox).delegate('a[role]',click,function(){
		  switch($(this).attr('role')){
			  case 'image':
			  	openFinder({
				  selectCount:9,
				  callBack:function(sdata){
					  $.each(sdata,function(i,item){
						  sendImg(data,item.file);
					  });
				  }
			  });
			  break;
		  };
	  });
	  	  
	 //处理快捷回复
	  var quickReplyBtn=$('a[role="quickReplyBtn"]',talkBox);
	  
	  quickReplyBtn.on(click,function(){
		   if(!quickReplyData){
			  Confirm('未设置快捷恢复,是否现在设置',function(){
				  xzHref('/xzcs/quickReply','new');
			  },'',{
				  confirmText:'前往设置'
			  }); 
			 return;  
		   };
		  if(quickReplyDialog){
			  quickReplyDialog.show();
		  }else{
			  
			   var el=$('<div></div>'),
				   ul=$('<ul class="quickReplyBox"></ul>').appendTo(el);
			  
			  $.each(quickReplyData,function(i,item){
				  var li=$('<li><a href="javascript:;">'+item.title+'</a></li>');
				  li.data('content',item.content).appendTo(ul).on(click,function(){
					  textarea.val(textarea.val()+$(this).data('content')).trigger('keyup');//.trigger('focus');
					  quickReplyDialog.hide();
				  });
			  });
			  
			  
			  quickReplyDialog=Dialog(el,{
					onBeforeClose:function(){
						quickReplyDialog.hide();
					},
					onClose:function(){
						
					},
					cancelText:'取消',
					scroll:true
			  });
		  };
	  });
	  
	  return talkBox;
	};
	
	/**
	 *设置消息发送事件
	 */  
	chatContainer.delegate("textarea.messageEditor",
		  {
			 keyup:function(e){
				   if(e.keyCode==16||e.keyCode==17){
					  var et=$(this);
					  setTimeout(function(){
						  et.removeData('shift');
					  },100);
				   };
				   if(e.keyCode==13&&!$(this).data('shift')){
					  sendInputMessage($(this));
				  };
				  if($(this).val()!=''){
					  $(this).parents('div.sendBox:first').addClass('focus').find('a[role="sendBtn"]').removeClass('disabled');
				  }else{
					  $(this).parents('div.sendBox:first').removeClass('focus').find('a[role="sendBtn"]').addClass('disabled');
				  }
			  },
			 keydown:function(e){
				 if(e.keyCode==16||e.keyCode==17){
					  $(this).data('shift',1);
				  };
				  
			},
			blur:function(){
				$(this).trigger('keyup');	
			}
	  }).delegate('a[role="sendBtn"]:not(.disabled)',click,function(){
		  var input=$(this).parents('div.sendBox:first').find('textarea.messageEditor');
		  sendInputMessage(input);
	  });
	  
	  function sendInputMessage(input){
		   var msg=input.val();
		  sendMessage(input.parents('div[role="chatDetail"]').data('data'),msg);
		  //清空输入框并获得焦点
		  input.val('').focus().trigger('keyup');
	  };
	 
	 //插入我的消息
	 function myMsg(data,isLoad){
		
		 insetMsg({
			    id:data.customId,
				type:'chat',
				news:0,
				latest:{
					type:'msgToCustom',
					time:data.time,
					msg:data.msg,
					id:data.id
				}
			 },isLoad);
		
	 };
	 
	 //插入接收的消息
	 function getMsg(data){
		  var news=$('#chat_'+data.user.userId).hasClass('active')?0:1;
		  insetMsg({
			    id:data.user.userId,
				type:'chat',
				news:news,
				latest:{
					type:'msgToServices',
					time:data.time,
					msg:data.msg,
					id:data.id
				}
			 });		 
	 };
	
	//插入消息
	function insetMsg(data,isLoad){
		var  id=data.id,
		 	 chatDetail=$('#chatDetail_'+id),
			 pushMsg=!chatDetail.length;
		 if(chatDetail.length){
			 insertChatMessage(chatDetail.find('div.chatDetailMain'),[data.latest],true,isLoad);
		 };	
		 
		 //更新会话排序
		 resetChat(data,pushMsg);
	};
	
	//插入对话消息
	insertChatMessage=function(el,data,news,isLoad){
		if(data&&data.length){
			var container=$('>div[role="chatDetailWrapper"]',el),
				showTime=true,
				lastTime=0,
				timeEl=container.find('div[role="showTime"]:'+(news?'last':'first'));
			if(timeEl.length){
				lastTime=timeEl.data('time');
			};
			$.each(data,function(i,item){
				 var custom=el.parents('div.chatDetail:first').data('data'),
				 	 icon=item.type=='msgToCustom'?myData.icon:custom.icon;
				 if(item.time){
				 	item.time=item.time.replace(/-/g,"/");
				 };
				 if(news){	 
					 showTime=new Date(item.time)-new Date(lastTime)>1000*60*5;
				 }else{
					 showTime=new Date(lastTime)-new Date(item.time)>1000*60*5;
				 };
				 var div=$('<div class="messageList clearfix" data-id="'+(item.id||'')+'">'+
						'<div class="message '+(item.type=='msgToCustom'?'me':'you')+'">'+
							'<div class="messageSystem" role="showTime" data-time="'+item.time+'" '+(showTime?'':'style="display:none"')+'>'+
							'<span class="content">'+item.time+'</span></div>'+
							'<span class="face">'+getThumbIcon(icon)+'</span>'+
							'<div class="content">'+
								'<div class="bubble '+(isLoad?'cloading" '+(item.id?' id="cloading_'+item.id+'"':''):'"')+' >'+
									'<div class="plain">'+msgToFile(item.msg)+'</div>'+
								'</div>'+
							'</div>'+
						'</div>'+
					'</div>');
				if(news){
					div.appendTo(container);
				}else{
					div.prependTo(container);
				};
				div.find('img[role="msgFile"]').on(click,function(e){
					viewMsgFile($(this),container);
				}).setThumbImageView();
				lastTime=item.time;
				
			});
			if(news){
				el.scrollToBottom();
			};	
		};
		
	};
	
	//发送消息
	sendMessage=function(data,msg){
		var time=getNowDate('all'),
			msg=msg.replace(/\n/g,"<br/>"),
			checkEl=$('<div />').html(msg),
			checkText=checkEl.text();
		
		checkEl.remove();
		if(!checkText)return;
		
		var id=getNowRandom(),
			mData={msg:msg,time:time,customId:data.id,id:id};	
		
		//把发送的信息先添加到自己的浏览器 DOM 中
		myMsg(mData,true);
		
		if($('#chat_'+data.id).hasClass('offline')){
		
		};
		
		//发送发话信息
		socket.emit('msgToCustom', mData,function(){
			$('#cloading_'+id).removeClass('cloading');
		});
	};
	
	
	
	//获取消息记录 
	function getChatRecord(el){
		var data=el.data('data'),
			container=el.find('div.chatDetailMain'),
			lastEl=el.find('div.messageList:first'),
			lastId='',
			scrollTop=container.scrollTop(),
			wrapper=container.find('>div[role="chatDetailWrapper"]'),
			height=wrapper.height(),
			loadingEl=$('<div>'+getContentLoading()+'</div>').prependTo(container),
			lHeight=loadingEl.outerHeight(),
			oTime=$.now(),
			clearLoading=function(){
				setTimeout(function(){
					container.removeData('loading');
				},300);
			};
		if(lastEl.length&&lastEl.data('id')){
			lastId=lastEl.data('id');
		};
		
		container.data('loading',1);
		rpcJSON('/message/getChatRecord',{
				siteId:myData.siteId,
				serviceId:myData.userId,
				customId:data.id,
				count:10,
				lastId:lastId
			},function(backData){
			
			var insert=function(){
					loadingEl.fadeOut(function(){
						insertChatMessage(container,backData.items);
						if(backData.lastone){
							el.find('div.messageList:first').data('lastone',1);
						};
						loadingEl.remove();
						var cHeight=wrapper.height()-height-lHeight;
						container.scrollTop(cHeight);
						clearLoading();
					});
				};
				
			if($.now()-oTime>1000){
				insert();
			}else{
				setTimeout(insert,1000-($.now()-oTime));
			};
			
		},function(){
			loadingEl.remove();
			clearLoading();	
		});
	};
	
	/**
	 *更新访客在线状态
	 */
	function setCustomState(data,state){
		var userId=data.userId,
			clientKey=data.clientKey,
			chatLi=$('#chat_'+userId),
			chatDetail=$('#chatDetail_'+userId);
		
		if(state=='online'){
			chatLi.addClass('online').removeClass('offline');
		}else if(state=='offline'){
			chatLi.addClass('offline').removeClass('online');
		};
		
		if(!state){
			state=chatLi.hasClass('online')?'online':'offline';
		};
		
		if(chatDetail.length){
			var chatDetailSend=$('div.chatDetailSend',chatDetail);
			if(state=='online'){
				chatDetail.addClass('online').removeClass('offline');
				chatDetailSend.removeClass('disabled')
				$('textarea',chatDetailSend).attr('placeholder','输入内容按换行键发送');
				$('div.mask',chatDetailSend).remove();
				
			}else{
				chatDetail.addClass('offline').removeClass('online');
				if(userId==clientKey){
					chatDetailSend.addClass('disabled');
					$('textarea',chatDetailSend).attr('placeholder','未登录访客已下线，不能发送消息').trigger('blur');
					$('<div class="mask" style="position:absolute;display:block;" />').appendTo(chatDetailSend);
				}else{
					$('textarea',chatDetailSend).attr('placeholder','用户已下线，消息将以留言发送').trigger('blur');
				};
			}
		};
			
	};
	
	/**
	 *设置消息列表点击事件
	 */
	$('#chatNav div.chatMain[role="chat"]').delegate('li:not(.active)',click,function(e){
		   e.stopPropagation();
		   var $li=$(this),
			   data=$li.data('data'),
			   id=$li.data('id');
		  if(isOpenWindow){
			  openChatWindow(data);
			  return;
		  };
		  	   
		   var chatDetail=$('#chatDetail_'+id),
			   newBox=!chatDetail.length;
		 
		  if(newBox){
			  chatDetail=createTalkBox(data);
		  };		  
		  if(isPhoneState){
			  
			  popWindow(chatDetail);
		  }else{
		 	 chatDetail.addClass('show').siblings('div.chatDetail').removeClass('show');
  		  };
		  $('div.chatList li.active').removeClass('active');
		  $li.addClass('active');
		  
		  var  container=chatDetail.find('div.chatDetailMain'),
		  	   num=$li.find('span[role="news"]').data('num');
		  
		  //清除未读消息记录
		  if(num>0){
			  rpcJSON('/message/readMessage',{customId:data.id});
		  };
		  
		  //修改未读消息数字
		  newMessage($li,-num);
		  
		  if(newBox){	  
			  if(data.list.length){
				  insertChatMessage(container,data.list,true);
				  data.list=[];
				  $li.data('data',data);
			  };
			  if(container.height()>container.find('>div[role="chatDetailWrapper"]').outerHeight()){
				  getChatRecord(chatDetail);
			  };
			  container.on('scroll',function(){
				 
				  if(container.scrollTop()<=0&&!container.data('loading')&&!container.find('div.messageList:first').data('lastone')){
					   getChatRecord(chatDetail);
				  };
			  });
		  }else{
			 container.scrollToBottom();
		  };
		  
		  setCustomState({
			  		userId:data.id,
					clientKey:data.clientKey
			  });
	   
	});
	 
	
	
	
	
	
	/**
	 *获取访客列表
	 */
	 
	var customContainer=$('#visitorsList');
	getCustom=function(update){
		
		if(!customContainer.data('ready')||update){
			var data={};
			if(update){
				customContainer.find('ul[role]').each(function(){
					var latest=$(this).find('>li:eq(0)');
					if(latest.length){
						data[$(this).attr('role')]={
							latestId:latest.data('data').id
						};
					};
				});
			};
			rpcJSON('/message/getCustom',data,function(backData){
					if(backData){
						for(key in backData){
							if(backData[key].length){
								var container=customContainer.find('ul[role="'+key+'"]');
								$.each(backData[key],function(i,item){
									var custom=newCustom(item);
									if(custom){
										custom.prependTo(container);
									};
								});
							};
						};
					};
					customContainer.data('ready',1);
				});
		};
	};
	
	//更新访客信息
	function updateCustom(backData){
		var id=backData.userId;
		if(!$('#custom_'+id).length){
			//存储访客信息
			var data={
					siteId:myData.siteId,
					userId:myData.userId,
					custom:backData
				};
			rpcJSON('/message/storageCustom',data,function(cData){
				backData.id=cData;
				//如果页面已经加载访客，插入访客
				if(customContainer.data('ready')){
					var custom=newCustom(backData),
						group=backData.guest?'guest':'user',
						container=customContainer.find('ul[role="'+group+'"]');
					custom.prependTo(container);
				};
			});
			
			
		};
	};
	
	//创建新的访客
	function newCustom(data){
		if($('#custom_'+data.userId).length){
			return null;
		};
		var html='<li id="custom_'+data.userId+'" data-id="'+data.userId+'" class="chatListItem">'+
					 '<a href="javascript:;" class="chatListBar setRow picRow">'+
						  '<div class="setRowPic">'+getThumbIcon(data.icon)+'</div>'+
						  '<div class="setRowMain">'+data.nickName+'</div>'+
					 '</a>'+
				  '</li>',
			 el=$(html).data('data',data);
		return el;
	};
	
	function getViewBox(data){
		var id=(data.id||data.userId),
			name=(data.name||data.nickName),
			clientKey=data.clientKey,
			html='<div class="chatDetailHead chatHead">'+
				  '<a class="return" href="javascript:;" role="close"><i class="xzicon-arrow-l"></i></a>'+
				  '<p class="title">详细资料</p>'+
				  '<a class="rightBtn" href="javascript:;" role="chat">会话</a>'+
			  '</div>'+
			  '<div class="chatDetailMain visitorsDetail"><div>'+
					  '<div class="visitorsInfo">'+
					'<div class="face">'+getThumbIcon(data.icon)+'</div>'+
					'<p class="name">'+name+'<a href="javascript:;">备注</a></p>'+
					'<p class="area" role="area"></p>'+
				'</div>'+
				'<div class="visitorsClassly" role="first">'+
				  
			  '</div>'+
				 '<div class="classlyhead clearfix">'+
					'<p class="classlytitle fl">TA的足迹</p>'+
					'<a class="classlyLink fr" href="javascript:;" role="sort"><i class="xzicon-sort2"></i><span>最近</span></a>'+
				'</div>'+
			  '<div class="classlyMain" role="pageView">'+
			  '</div></div></div>',
		viewBox=$('<div id="view_'+id+'" class="chatDetail show" style="z-index:112" >'+html+'</div>');
		
		var closeView=function(callback){
			    if(isPhoneState){
					backWindow(viewBox);
				}else{
					viewBox.removeClass('show');
				};
				$('#custom_'+id).removeClass('active');
				fireHandler(callback);
			};
		
	  
		viewBox.data('data',data).appendTo(chatContainer);
		
		
		//获取基本信息
		rpcJSON('/message/getCustomInfo',{userId:id,clientKey:clientKey},function(backData){
			if(backData.first){
				var html='<div class="classlyhead"><p class="classlytitle">首次访问</p></div>'+
						  '<div class="classlyMain">'+
						  	'<div class="visitorsItem">'+
								  '<div class="clearfix visitorsTop">'+
									'<time class="time fr">'+backData.first.time+'</time>'+
									'<p class="title">'+(backData.first.title||'未命名')+'</p>'+
								'</div>'+
								  '<p class="url">地址：<a href="'+backData.first.url+'" tab="new" target="_blank" tabtitle="'+backData.first.title+'">'+backData.first.url+'</a></p>'+
								  '<p class="url">来源：'+(backData.first.sources?'<a href="'+backData.first.sources+'" tab="new" target="_blank" tabtitle="来源">'+backData.first.sources+'</a>':'直接访问')+'</p>'+
							  '</div>'+
						 '</div>';
				$('div[role="first"]',viewBox).append(html);	  
			};
			if(backData.area){
				$('p[role="area"]',viewBox).html(backData.area);
			};
			
		});
		
		//加载足迹记录
		var scrollWrapper=viewBox.find('div.chatDetailMain'),
			pvContainer=viewBox.find('div[role="pageView"]');
		scrollWrapper.scrollLoad({
			contentContainer:pvContainer,
			data:{userId:id,clientKey:clientKey},
			load:function(ldata,callback,onError){
				ldata['sort']=pvContainer.data('sort')||0;
				rpcJSON('/visitingStatistic/getpv',ldata,function(backData){
					  if(backData.items&&backData.items.length){
						  insertPV(pvContainer,backData.items);
					  }else{
						  pvContainer.children(':last').data('lastone',1);
						  scrollWrapper.data('lastone',1);
					  };
					  if(backData.lastone){
						  pvContainer.children(':last').data('lastone',1);
						  scrollWrapper.data('lastone',1);  
					  };
					  callback();
				  },onError);
			},
			autoLoad:true
		  });
		
				
		viewBox.delegate('a[role]',click,function(e){
				  e.stopPropagation();
				  switch($(this).attr('role')){
					  case 'close':
						closeView();
						
					  break;
					  
					   case 'chat':
						var chatLi=$('#chat_'+id);
						if(chatLi.length){
							if(chatLi.hasClass('active')){
								
								if(isPhoneState){
									popWindow($('#chatDetail_'+id));
								}else{
									$('#chatDetail_'+id).addClass('show');
									closeView();
								};
							}else{
								chatLi.trigger(click);
								if(!isPhoneState){								
									closeView();
								};
							}
						}else{
							
							createChatList([{
									id:id,
									clientKey:clientKey,
									name:name,
									type:'chat'
								}]);
							$('#chat_'+id).trigger(click);
							if(!isPhoneState){
								closeView();
							};
						};
						
					  break;
					  
					  case 'sort':
					  	scrollWrapper.removeData('lastone');
						if(pvContainer.data('sort')){
							$(this).find('span').text('最近');
							pvContainer.data('sort',0).empty();
							fireHandler(scrollWrapper.data('reload'));
						}else{
							$(this).find('span').text('最早');
							pvContainer.data('sort',1).empty();
							fireHandler(scrollWrapper.data('reload'));
						};
					  break;
				  };
			}).delegate('a[target]',click,function(){
				if(top.phoneFrame&&appSys=='web'){
					miniMessageWindow();
				};
			});	
			
			return viewBox;
	};
		
	//查看更多
	function viewMore(data){
		var id=(data.id||data.userId),
			viewBox=$('#view_'+id);
				
		
		if(!viewBox.length){
			viewBox=getViewBox(data);
		};
		if(isPhoneState){
			popWindow(viewBox);
		}else{
			$('>div.chatDetail.show',chatContainer).removeClass('show');
			viewBox.addClass('show');
		};
		  
	};
	
	//插入访问记录
	function insertPV(el,data){
		if(data&&data.length){
			$.each(data,function(i,item){
				$('<a href="'+item.url+'" tab="new" tabtitle="'+(item.title||'未命名')+'" target="_blank"  data-id="'+item.id+'" lastone="'+item.lastone+'"><div class="visitorsItem" data-id="'+item.id+'">'+
					'<div class="clearfix visitorsTop">'+
						'<time class="time fr">'+item.time+'</time>'+
						'<p class="title">'+(item.title||'未命名')+'</p>'+
					'</div>'+
					'<p class="url">'+item.url+'</p>'+
				'</div></a>').data('data',item).appendTo(el);
			});
		}
	};
	
	customContainer.delegate('li.chatListItem',click,function(){
		
		var data=$(this).data('data'),
			vData=$.extend(true,data,{id:data.userId});
		 if(isOpenWindow){
			  openCustomDetailWindow(data);
		 }else{	
			viewMore(vData);
			$('div.chatList li.active').removeClass('active');
			$(this).addClass('active');
		};
		
		
	});
		
	
	//队列处理
	var queueList=$('#queueList');
	
	//客户进入排队	
	function insertQueue(data){
		var id=data.userId,
			type=data.guest?'guest':'user'; 
		if(!$('#queue_'+id).length){
			
			var sources=data.sources?'<a href="'+data.sources+'" tab="new" tabtitle="来源">'+data.sources+'</a>':'直接输入',
				html='<li class="queueItem chatListItem" id="queue_'+id+'" data-id="'+id+'" >'+
							'<div class="queueBar chatListBar setRow picRow">'+
								'<div class="setRowPic">'+getThumbIcon(data.icon)+'</div>'+
								'<div class="setRowMain queueBarMain chatListMain">'+
									'<div class="setRowTop clearfix">'+
										'<p class="fr time" role="time" data-time="'+data.time+'">'+data.time+'</p>'+
										'<p class="name">'+data.nickName+'</p>'+
									'</div>'+
									'<div class="setRowBtm clearfix">'+
										'<a href="javascript:;" class="fr button b4" role="connect">接入</a>'+
										'<div class="info">'+
											'<p>页面：<a href="'+data.sourcesURL+'" tab="new" tabtitle="所在页面">'+data.sourcesURL+'</a></p>'+
											'<p>来源：'+sources+'</p>'+
										'</div>'+
									'</div>'+
								'</div>'+
							'</div>'+
						'</li>',
				el=$(html).data('data',data).appendTo($('ul[role="'+type+'"]',queueList));
				el.parent().parent().show();
			 newMessage(el,1);
			
			 el.find('p[role="time"]').dateDiff();
			 
			 el.find('a[role="connect"]').on(click,function(e){
				 removeQueue(data);
				 connectCustom(data);
			 });
			 
			 if(appSys=='web'){
				 el.delegate('a[tab]',click,function(){
					miniMessageWindow();
				});	
			 };
		};
	};
	
	//删除排队信息	
	function removeQueue(data){
		 var el=$('#queue_'+data.userId);
		 if(el.length){
			 newMessage(el,-1);
			 var pel=el.parent().parent(),
			 	 vl=el.siblings().length;
			 el.hideRemove(function(){
				if(!vl){
					pel.hide();
				};
			 });
		 };
	};
	
	//连接客户
	function connectCustom(data){
		//向服务器发送连接信息
		socket.emit('connectCustom', data,function(){
			if($('#chat_'+data.userId).length){
				$('#chat_'+data.userId).trigger(click);
				$('#messageTab li[role="chat"]').trigger(click);
			};
		});
	};
	
	//客户取消队列
	function exitQueue(data){
		removeQueue(data);
	};
	
	//打开访客详细资料窗口
	function openCustomDetailWindow(data){
		var src=customerDetailUrl+'?id='+data.id+'&name='+(data.name||data.nickName)+'&clientKey='+data.clientKey+'&userId='+data.userId;
		xzHref(src,'new',data.name);
	};
	
	//打开会话窗口
	function openChatWindow(data){
		var src=chatUrl+'?id='+data.id+'&name='+(data.name||data.nickName)+'&clientKey='+data.clientKey+'&userId='+data.userId;
		xzHref(src,'new',data.name);

	};
	
	

	
}());
